//
//  DRCividIO.h
//  SoundRecorder
//
//  Created by mmivi on 14.04.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CividFile.h"

typedef enum
	{
		DRCividIOWriteMode,
		DRCividIOReadMode
	} DRCividIOMode;


@interface DRCividIO : NSObject {
	NSString * _fullPath;
	DRCividIOMode _mode;
	
	id _delegate, _dataDestination, _dataSource;
	
	BOOL _keepRunning, _stopNow, _finalize, _pause;
	
	long _writenFrames, _readFrames;
	
	CividInfo _fileInfo;
	
	BOOL isAdapterEnabled;
	double frameRate;
}

- (id) initWithFile: (NSString *)fullPath mode: (DRCividIOMode)mode;

- (CividInfo)fileInfo;

- (void)start;
- (void)stop;
- (void)pause: (BOOL)flag;
- (void)finalize;

- (void)setDelegate: (id)object;
- (void)setDataSource: (id)object;
- (void)setDataDestination: (id)object;

+ (CividInfo)infoForFile: (NSString *)fullPath;
+ (NSImage *)imageAtIndex: (unsigned long)index ofFile: (NSString *)fullPath;
@end

@interface NSObject (DRCividIODelegateInformalProtocol)

- (void)DRCividIODidStop: (DRCividIO *)cividIO;
- (void)DRCividIODidStart: (DRCividIO *)cividIO;

@end