//
//  DRCividXManager.h
//  SoundRecorder
//
//  Created by mmivi on 26.04.09.
//  Copyright 2009 Deep IT. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define DR_CXMNGR_VERSION_KEY @"CividX Version"
#define DR_CXMNGR_TRACKS_KEY @"Tracks"
#define DR_CXMNGR_TRACKNAME_KEY @"Name"
#define DR_CXMNGR_TRACKTYPE_KEY @"Type"
#define DR_CXMNGR_TRACKPATH_KEY @"Path"
#define DR_CXMNGR_PLAINMOVIE_KEY @"PlainMovie"

#define DR_CXMNGR_TRACKOFFSET_KEY @"TimeOffset"

#define kDRCividXVideoResourceID @"video"
#define kDRCividXAudioResourceID @"audio"
#define kDRCividXCursorsResourceID @"cursors"
#define kDRCividXSystemAudioResourceID @"systemaudio"

typedef enum
	{
		DRCividXVideoResource,
		DRCividXAudioResource,
		DRCividXSystemAudioResource,
		DRCividXCursorsResource,
		DRCividXMovieResource
	} DRCividXManagerResourceType;

@interface DRCividXManager : NSObject {
	NSString * _filePath;
	
	NSMutableDictionary * _infoDict;
	BOOL _package;
	BOOL _exists;
}

- (id)initWithFile: (NSString *)fullPath;
- (void)createCividX;
- (void)removeCividX;
- (BOOL)exists;
- (BOOL)isPackage;
- (NSString *)createPathForPackageResource: (DRCividXManagerResourceType)type;
- (NSString *)pathForPackageResource: (DRCividXManagerResourceType)type;
- (NSString *)pathForResource: (DRCividXManagerResourceType)type;
- (NSString *)extractMovie;
- (NSString *)path;
- (unsigned long long)fileSize;

- (void)setPropertie: (NSString *)key value: (id)val forResource: (DRCividXManagerResourceType)type;
- (NSDictionary *)propertiesForResource: (DRCividXManagerResourceType)type;

@end
