//
//  DRQueue.h
//  DeepRecorder
//
//  Created by mmivi on 13.03.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define DR_QUE_MIN_SHARED_LIMIT (long long)(1024 * 1024 * 100) // 100 MB
#define DR_QUE_MIN_LIMIT (long long)(1024 * 1024 * 40) // 40 MB
#define DR_QUE_SYS_MEM_USAGE_RATIO ((double)0.5)

extern const long long kDRQueueDefaultLimit;
extern const long long kDRQueueNoLimit;

@protocol DRQueueObjectProtocol

- (long long)dataSize;

@end

@interface DRQueue : NSObject {
	NSMutableArray * _objects;
	NSRecursiveLock * _queLock;
	long long _limit;
}

- (void)addObject: (id <DRQueueObjectProtocol>)newObject;
- (id)nextObject;
- (BOOL)canAcceptObject;
- (void)flush;
- (long)count;
- (BOOL)hasObjects;
- (long long)limit;
- (void)setLimit: (long long)newLimit;

@end
