//
//  DRSystemSoundRecorder.h
//  DeepRecorder
//
//  Created by mmivi on 15.06.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreAudio/CoreAudio.h>

#import "DRSoundInputRecorder.h"
#import "DRSoundPacket.h"
#import "DRQueue.h"

enum {
	kSysSndStartPlayThru,
	kSysSndStopPlayThru
};

enum {
	kIOStatusStarting,
	kIOStatusRunning,
	kIOStatusRequestStop,
	kIOStatusOff
};

@interface DRSystemSoundSupport : NSObject {
	DRQueue * _thruBuffer;
	AudioDeviceID _soundflower2ch;
	
	int _inputState, _outputState;
}

+ (void)preparePlayThru;
+ (void)releasePlayThru;

+ (id)sharedSystemSoundSupport;

- (void)setPlayThru: (int)state;
- (OSStatus)inputProc: (AudioDeviceID) inDevice :(const AudioTimeStamp*) inNow :(const AudioBufferList*) inInputData :(const AudioTimeStamp*)inInputTime :(AudioBufferList*) outOutputData :(const AudioTimeStamp*) inOutputTime;
- (OSStatus)outputProc: (AudioDeviceID) inDevice :(const AudioTimeStamp*) inNow :(const AudioBufferList*) inInputData :(const AudioTimeStamp*)inInputTime :(AudioBufferList*) outOutputData :(const AudioTimeStamp*) inOutputTime;

+ (void)installDriver;
+ (void)updateDriverIfNeeded;
+ (void)uninstallDriver;
+ (BOOL)isDriverInstalled;
+ (BOOL)isInstallingDriver;

@end
